#pragma semicolon 1

#include <sourcemod>
#include <cstrike>

#define PLUGIN_VERSION "1.0"

new Handle:Respawn_Timer;
new Handle:RespawnTime;


public Plugin:myinfo =
{
	name = "RespawnTest",
	author = "DRoN4Ik",
	description = "Respawn players",
	version = PLUGIN_VERSION,
	url = ""
};
public OnPluginStart()
{
	HookEvent("round_start", Round_Start, EventHookMode_PostNoCopy);
	HookEvent("round_end", Round_End, EventHookMode_PostNoCopy);
	HookEvent("player_death", Player_Death);
	RespawnTime = CreateConVar("respawn_time", "12", "Respawn time");
}
public Round_Start(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(Respawn_Timer != INVALID_HANDLE)
	{
		KillTimer(Respawn_Timer);
	}
	Respawn_Timer = CreateTimer(float(GetConVarInt(RespawnTime)), StopTimer);
	new Var_Sec = GetConVarInt(RespawnTime);
	PrintToChatAll("\x04[RESPAWNER]: \x03Если в умрёте в течении %i сек, вы будете возрождены!", Var_Sec);
}
public Player_Death(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(Respawn_Timer != INVALID_HANDLE)
	{
		CreateTimer(1.0, TimerRespawn, GetClientOfUserId(GetEventInt(event, "userid")));
	}
}
public Round_End(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(Respawn_Timer != INVALID_HANDLE)
	{
		KillTimer(Respawn_Timer);
		Respawn_Timer = INVALID_HANDLE;
	}
}
public Action:StopTimer(Handle:timer)
{
	Respawn_Timer = INVALID_HANDLE;
}
public Action:TimerRespawn(Handle:timer, any:client)
{
	if(IsClientInGame(client) && !IsPlayerAlive(client) && GetClientTeam(client) > 1)
	{
		CS_RespawnPlayer(client);
		PrintToChat(client, "\x04[RESPAWNER]: \x03Вы были возрождены!");
	}
}